var poang = 0;                      // Här sparas nuvarande poäng
var highscore = 0;                  // Här sparas högsta poängen sedan appen startades
var starttid;                       // Här sparas tiden då spelaren klickade på startknappen, så att man vet när spelet ska ta slut
var TOTAL_SPELTID_SEKUNDER = 30;    // Hur länge man vill att ett spel ska vara
var TID_PER_SYMBOL_SEKUNDER = 2;    // Hur lång tid man som mest ska ha på sig att peta

// Körs när sidan just har laddats färdigt
$(function () {
    //
    // Körs när användaren petar på startknappen. Gömmer startsidan, visar spelplanen och startar spelet och nedräkningen
    //
    $("#starta_spelet").click(function () { 
        $("#titelsida").fadeOut("slow", function () {
            poang = 0;
            $("#poang").text(poang);
            $("#tidkvar").css({"width":"100%"});
            $("#spelplan").fadeIn("slow", function () {

                starttid = new Date().getTime();
                $("#tidkvar").animate({
                    width: 0
                }, TOTAL_SPELTID_SEKUNDER * 1000, "linear");
                nasta_steg();
            });
        });
    });

    //
    // Körs när användaren petar på en cirkel. Adderar poäng och justerar highscore om det behövs.
    //
    $("#spelplan").on("touchstart", ".klickyta", function (e) { 
        e.preventDefault();
        if ($(this).data("klickad") != "1") {
            $(this).data("klickad", 1);
            $(this).stop();
            var startstorlek = $(this).data("startstorlek");
            var storlek_nu = $(this).width();
            var dennapoang = Math.round(100 * (storlek_nu / startstorlek));
            poang += dennapoang;
            var nuvarande_highscore = Math.max(highscore, poang);
            $("#poang").text(poang);
            $("#highscore").text(nuvarande_highscore);
            $("#dennapoang").text("+" + dennapoang);
            $("#dennapoang").show().delay(200).fadeOut("slow");

            $(this).fadeOut("fast", function () {
                nasta_steg();
            });
        }
    });

    //
    // Körs när användaren petar UTANFÖR en cirkel. Drar av poäng och justerar highscore om det behövs.
    //
    $("#spelplan").on("touchstart", "#spelyta", function () { 
        var klickyta = $(".klickyta");
        if ($(klickyta).data("klickad") != "1") {
            $(klickyta).data("klickad", 1);
            $(klickyta).stop();
            var startstorlek = $(klickyta).data("startstorlek");
            var storlek_nu = $(klickyta).width();
            var dennapoang = Math.round(100 * (storlek_nu / startstorlek));
            poang = Math.max(0, poang - dennapoang);
            var nuvarande_highscore = Math.max(highscore, poang);
            $("#poang").text(poang);
            $("#highscore").text(nuvarande_highscore);
            $("#dennapoang").text("-" + dennapoang);
            $("#dennapoang").show().delay(200).fadeOut("slow");

            $(klickyta).fadeOut("fast", function () {
                nasta_steg();
            });
        }
    });

    //
    // Körs när användaren petar på "game over"-skylten. Gömmer skylten och visar startsidan.
    //
    $("#game_over").click(function () {
        $("#spelplan").fadeOut("slow", function () {
            $("#game_over").hide();
            $("#titelsida").fadeIn("slow");
        });
    });

});

// Slut på kod som körs när sidan just har laddats färdigt


//
// Körs när spelet ska ta nästa steg, det vill säga antingen visa en ny cirkel eller visa "game over"-skylten
//
function nasta_steg() {
    var nu = new Date().getTime();
    var speltid = nu - starttid;
    if (speltid < TOTAL_SPELTID_SEKUNDER * 1000) { 
        // Tiden inte slut än, fortsätt spelet
        visa_en_symbol();
    } else { 
        //Tiden slut, visa "game over"-skylten
        highscore = Math.max(highscore, poang);
        $("#game_over").fadeIn("slow");
    }
}

//
// Här skapas en ny cirkel med slumpmässig storlek och färg. Cirkeln visas sedan på skärmen, och en animation skapas som gör att cirkeln krymper ihop.
//
function visa_en_symbol() {
    // Rensa bort den tidigare cirkeln, om någon sådan finns
    $("#spelyta").empty();

    // Ta reda på hur stor spelytan är, så att den nya cirkeln hamnar inom ramarna
    var spelyta_bredd = $("#spelyta").width();
    var spelyta_hojd = $("#spelyta").height();

    // Slumpa fram en storlek samt var på skärmen den nya cirkeln ska hamna
    var startstorlek = 100 + Math.floor(Math.random() * 100);
    var x = Math.floor(Math.random() * (spelyta_bredd - startstorlek));
    var y = Math.floor(Math.random() * (spelyta_hojd - startstorlek));

    // Slumpa fram en färg med värden för R G B (röd, grön, blå) mellan 55 och 255. Den undre gränsen 55 gör att cirklarna inte kan bli för mörka
    var r = 55 + Math.floor(Math.random() * 200);
    var g = 55 + Math.floor(Math.random() * 200);
    var b = 55 + Math.floor(Math.random() * 200);

    // Skapa det html-element som är själva cirkeln, och lägg till det på spelytan
    var div = "<div data-startstorlek='" + startstorlek + "' class='klickyta' style='left:" + x +"px; top:" + y + "px; width:" + startstorlek + "px; height:" + startstorlek + "px;background-color:rgba(" + r + ", " + g + ", " + b + ", 1.0)'></div>";
    $("#spelyta").append(div);

    // Skapa den animation som får cirkeln att krympa ihop från den slumpade startstorleken ned till 0
    // Lägg också till en funktion som får spelet att gå vidare om användaren inte petat innan animationen är klar
    $(".klickyta").animate({
        width: 0,
        height: 0,
        left: x + (startstorlek / 2),
        top: y + (startstorlek / 2)
    }, TID_PER_SYMBOL_SEKUNDER * 1000, "linear", function () {
        $("#spelyta .klickyta").fadeOut("fast", function () {
            setTimeout(nasta_steg, 100);
        });
    });
}

//
// Koden nedan är för Phonegap. I just den här appen används inga av specialfunktionerna i PhoneGap, så koden nedan skulle egentligen kunna tas bort.
//
var app = {
    // Application Constructor
    initialize: function () {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function () {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function () {
        app.receivedEvent('deviceready');
    },
    // Update DOM on a Received Event
    receivedEvent: function (id) {
        console.log('Received Event: ' + id);
    }
};
